﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Media.Media3D;
using System.Windows.Media.Animation;

namespace Wpf3D2
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            // モデルの追加
            for (int i = 0; i < 100; i++)
            {
                ModelUIElement3D element = new ModelUIElement3D();
                Model3DGroup models = this.TryFindResource("starModel") as Model3DGroup;
                if (models != null)
                {
                    element.Model = models;
                    element.Transform = new TranslateTransform3D(GetRandomVector3D());
                    this.modelsCountainer.Children.Add(element);
                    System.Threading.Thread.Sleep(10); // 描画用に待機
                }
            }
        }

        private Vector3D GetRandomVector3D()
        {
            Random random = new System.Random();
            // -1.0～1.0 の値をランダムに生成
            return new Vector3D((random.NextDouble() - 0.5) * 2, (random.NextDouble() - 0.5) * 2, (random.NextDouble() - 0.5) * 2);
        }

        private void StartRotation()
        {
            DoubleAnimation animation = new DoubleAnimation();
            animation.From = 0;
            animation.To = 360;
            animation.Duration = TimeSpan.FromSeconds(1);
            animation.RepeatBehavior = RepeatBehavior.Forever;
            this.cameraAngleRotationY.BeginAnimation(AxisAngleRotation3D.AngleProperty, animation);
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            StartRotation();
        }
    }
}
